<?php

/*
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license. If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   Troubleticket
 * @package    QuickTicket
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2008-2012 The PHP Group
 * @license    http://www.php.net/license  PHP License 3.0
 * @version    1.9.0.3 build:20081001
 * @link       http://www.qt-cute/doc/package/qtg
 * @since      File available since Release 1.0.0
 * @deprecated File deprecated in Release 2.0.0
 *
 */

session_start();
require_once('bin/qti_init.php');
include(Translate('qti_lang_adm.inc'));
if ( $oVIP->role!='A' ) die($L['E_admin']);

// INITIALISE

$arrYears = array(
  '*'=>'&lt; '.$L['All'].' &gt;',
  strval(date('Y'))=>strval(date('Y')),
  strval(date('Y')-1)=>strval(date('Y')-1),
  'old'=>'&lt; '.strval(date('Y')-1)
  );

if ( !isset($_SESSION['m_export']) )
{
  $_SESSION['m_export'] = array(
  'title'     => 'export_'.date('Ymd').'.txt',
  'format'    => 'CSV',
  'delimit'   => ';',
  'enclose'   => '"',
  'null'      => 'NULL',
  'dropbbc'   => 'Y',
  'firstline' => 'Y');
}

$oVIP->selfurl = 'qtim_export_adm.php';
$oVIP->selfname = $L['export']['Admin'];
$oVIP->exiturl = $oVIP->selfurl;
$oVIP->exitname = $oVIP->selfname;
$strPageversion = $L['export']['Version'].' 1.9<br/>';

// --------
// SUBMITTED
// --------

if ( isset($_POST['submit']) )
{
  // read and check mandatory
  $_SESSION['m_export']['format'] = trim($_POST['format']);
  $_SESSION['m_export']['delimit'] = trim($_POST['delimiter']);
  $_SESSION['m_export']['enclose'] = $_POST['enclose']; if ( get_magic_quotes_gpc() ) $_SESSION['m_export']['enclose'] = stripslashes($_POST['enclose']);
  $_SESSION['m_export']['null'] = trim($_POST['null']);
  if ( isset($_POST['dropbbc']) ) { $_SESSION['m_export']['dropbbc']='Y'; } else { $_SESSION['m_export']['dropbbc']='N'; }
  if ( isset($_POST['firstline']) ) { $_SESSION['m_export']['firstline']='Y'; } else { $_SESSION['m_export']['firstline']='N'; }
  if ( empty($_SESSION['m_export']['delimit']) ) $qti_error=$L['export']['Delimiter'].S.$L['E_invalid'];

  // check values
  if ( empty($qti_error) )
  {
    if ( strlen($_SESSION['m_export']['delimit'])==1 )
    {
    if ( ereg('[0-9A-Za-z]',$_SESSION['m_export']['delimit']) ) $qti_error=$L['export']['Delimiter'].S.$L['E_invalid'];
    }
    if ( strlen($_SESSION['m_export']['enclose'])==1 )
    {
    if ( ereg('[0-9A-Za-z]',$_SESSION['m_export']['enclose']) ) $qti_error=$L['export']['Encloser'].S.$L['E_invalid'];
    }
    if ( $_SESSION['m_export']['format']=='SQL' ) $_SESSION['m_export']['delimit'] = ',';
  }

  // check conflict
  $strEnclose = '"'; if ( $_SESSION['m_export']['enclose']=='"' || $_SESSION['m_export']['enclose']=="'" ) $strEnclose = '';
  $strDelimit = ';'; if ( $_SESSION['m_export']['delimit']==';' ) $strDelimit = ',';

  // EXPORT COUNT
  if ( empty($qti_error) )
  {
    // query
    $strWhere = ' WHERE ';
    if ( $_POST['section']!='*' ) { $strWhere .= ' p.forum='.$_POST['section']; } else { $strWhere .= 'p.forum>=0'; }
    if ( $_POST['year']!='*' )
    {
      if ( $_POST['year']=='old' ) { $strOp='<'; $_POST['year']=strval(Date('Y')-1); } else { $strOp='='; }
      switch(substr($oDB->type,0,5))
      {
      case 'mysql': $strWhere .= ' AND LEFT(p.issuedate,4)'.$strOp.'"'.$_POST['year'].'"'; break;
      case 'mssql': $strWhere .= ' AND LEFT(p.issuedate,4)'.$strOp.'"'.$_POST['year'].'"'; break;
      case 'pg':    $strWhere .= ' AND SUBSTRING(p.issuedate,1,4)'.$strOp.'"'.$_POST['year'].'"'; break;
      case 'ibase': $strWhere .= ' AND SUBSTRING(p.issuedate FROM 1 FOR 4)'.$strOp.'"'.$_POST['year'].'"'; break;
      case 'sqlit': $strWhere .= ' AND SUBSTR(p.issuedate,1,4)'.$strOp.'"'.$_POST['year'].'"'; break;
      case 'acces': $strWhere .= ' AND LEFT(p.issuedate,4)'.$strOp.'"'.$_POST['year'].'"'; break;
      case 'db2':   $strWhere .= ' AND SUBSTR(p.issuedate,1,4)'.$strOp.'"'.$_POST['year'].'"'; break;
      case 'ifx':   $strWhere .= ' AND SUBSTRING(p.issuedate,1,4)'.$strOp.'"'.$_POST['year'].'"'; break;
      case 'oci':   $strWhere .= ' AND SUBSTR(p.issuedate,1,4)'.$strOp.'"'.$_POST['year'].'"'; break;
      default: die('Unknown db type '.$oDB->type);
      }
    }

    // count
    $strQ = 'SELECT count(*) as countid FROM '.TABPOST.' p INNER JOIN '.TABTOPIC.' t ON p.topic=t.id '.$strWhere;
    $oDB->Query($strQ);
    $row=$oDB->Getrow();
    if ( $row['countid']==0 ) $qti_error='No data found';
  }

  // ------
  // EXPORT
  // ------

  if ( empty($qti_error) )
  {
    $strQ = 'SELECT p.id,p.forum,p.topic,p.type,p.username,p.title,p.issuedate,p.textmsg,t.numid,t.x,t.y,t.z FROM '.TABPOST.' p INNER JOIN '.TABTOPIC.' t ON p.topic=t.id '.$strWhere;

    if (!headers_sent())
    {
      header('Content-Type: text/plain; charset='.QTI_HTML_CHAR);
      header('Content-Disposition: attachment; filename="'.$_SESSION['m_export']['title'].'"');
    }

    if ( $_SESSION['m_export']['firstline']=='Y' )
    {
    echo ($_SESSION['m_export']['format']=='SQL' ? '# ' : '').$_SESSION['m_export']['enclose'].'id'.$_SESSION['m_export']['enclose'].$_SESSION['m_export']['delimit'].$_SESSION['m_export']['enclose'].'forum'.$_SESSION['m_export']['enclose'].$_SESSION['m_export']['delimit'].$_SESSION['m_export']['enclose']."topic".$_SESSION['m_export']['enclose'].$_SESSION['m_export']['delimit'].$_SESSION['m_export']['enclose']."type".$_SESSION['m_export']['enclose'].$_SESSION['m_export']['delimit'].$_SESSION['m_export']['enclose']."username".$_SESSION['m_export']['enclose'].$_SESSION['m_export']['delimit'].$_SESSION['m_export']['enclose']."title".$_SESSION['m_export']['enclose'].$_SESSION['m_export']['delimit'].$_SESSION['m_export']['enclose']."issuedate".$_SESSION['m_export']['enclose'].$_SESSION['m_export']['delimit'].$_SESSION['m_export']['enclose']."numid".$_SESSION['m_export']['enclose'].$_SESSION['m_export']['delimit'].$_SESSION['m_export']['enclose']."textmsg".$_SESSION['m_export']['enclose'].$_SESSION['m_export']['delimit'].$_SESSION['m_export']['enclose'].'x'.$_SESSION['m_export']['enclose'].$_SESSION['m_export']['delimit'].$_SESSION['m_export']['enclose'].'y'.$_SESSION['m_export']['enclose'].$_SESSION['m_export']['delimit'].$_SESSION['m_export']['enclose'].'z'.$_SESSION['m_export']['enclose']."\r\n";
    }

    $oDB->Query($strQ);
    While( $row=$oDB->Getrow() )
    {
      $str = $row['id'].$_SESSION['m_export']['delimit'];
      $str .= $row['forum'].$_SESSION['m_export']['delimit'];
      $str .= $row['topic'].$_SESSION['m_export']['delimit'];
      $str .= (empty($row['type']) ? $_SESSION['m_export']['null'] : $_SESSION['m_export']['enclose'].$row['type'].$_SESSION['m_export']['enclose'] ).$_SESSION['m_export']['delimit'];

        // username pre-process
        $txt = $row['username'];
        if ( !is_string($txt) ) $txt='';
        $txt = QTconv($txt,'-4');
        $txt = str_replace($_SESSION['m_export']['enclose'],$strEnclose,$txt);
        $txt = str_replace($_SESSION['m_export']['delimit'],$strDelimit,$txt);

      $str .= (empty($row['username']) ? $_SESSION['m_export']['null'] : $_SESSION['m_export']['enclose'].$txt.$_SESSION['m_export']['enclose'] ).$_SESSION['m_export']['delimit'];

        // title pre-process
        $txt = $row['title'];
        if ( !is_string($txt) ) $txt='';
        $txt = QTconv($txt,'-4');
        $txt = str_replace($_SESSION['m_export']['enclose'],$strEnclose,$txt);
        $txt = str_replace($_SESSION['m_export']['delimit'],$strDelimit,$txt);

      $str .= (empty($row['title']) ? $_SESSION['m_export']['null'] : $_SESSION['m_export']['enclose'].$txt.$_SESSION['m_export']['enclose'] ).$_SESSION['m_export']['delimit'];
      $str .= (empty($row['issuedate']) ? $_SESSION['m_export']['null'] : $_SESSION['m_export']['enclose'].str_replace(':','',$row['issuedate']).$_SESSION['m_export']['enclose'] ).$_SESSION['m_export']['delimit'];
      $str .= $row['numid'].$_SESSION['m_export']['delimit'];

        // text pre-process
        if ( $oDB->type=='db2' || $oDB->type=='db2' ) {
        if ( $row['type']=='D' ) {
          $row['textmsg'] = $row['textmsg2'];
        }}
        $txt = $row['textmsg'];
        if ( !is_string($txt) ) $txt='';
        if ( $_SESSION['m_export']['dropbbc']=='Y' && strlen($txt)>5 ) $txt = QTbbc($txt,'drop');
        $txt = QTconv($txt,'-4');
        $txt = str_replace($_SESSION['m_export']['enclose'],$strEnclose,$txt);
        $txt = str_replace($_SESSION['m_export']['delimit'],$strDelimit,$txt);
        $txt = str_replace("\r\n","\\n",$txt);
        $txt = str_replace("\n","\\n",$txt);

      $str .= $_SESSION['m_export']['enclose'].$txt.$_SESSION['m_export']['enclose'].$_SESSION['m_export']['delimit'];

        // x pre-process
        $txt = strval($row['x']);
        if ( empty($txt) ) $txt='0';
        if ( substr($txt,0,6)=='0.0000' ) $txt='0';

      $str .= $_SESSION['m_export']['enclose'].$txt.$_SESSION['m_export']['enclose'].$_SESSION['m_export']['delimit'];

        // y pre-process
        $txt = strval($row['y']);
        if ( empty($txt) ) $txt='0';
        if ( substr($txt,0,6)=='0.0000' ) $txt='0';

      $str .= $_SESSION['m_export']['enclose'].$txt.$_SESSION['m_export']['enclose'].$_SESSION['m_export']['delimit'];

        // z pre-process
        $txt = strval($row['z']);
        if ( empty($txt) ) $txt='0';
        if ( substr($txt,0,6)=='0.0000' ) $txt='0';

      $str .= $_SESSION['m_export']['enclose'].$txt.$_SESSION['m_export']['enclose'];

      if ( $_SESSION['m_export']["format"]=='CSV' )
      {
      $content = $str."\r\n";
      }
      else
      {
      $content = 'INSERT INTO '.TABPOST.' (id,forum,topic,type,username,title,issuedate,numid,textmsg,x,y,z) VALUES ('.$str.")\r\n";
      }

      echo $content;
    }
    exit;
  }

}

// --------
// HTML START
// --------

include('qti_adm_p_header.php');
include('qti_adm_p_title.php');

// FORM

echo '
<script type="text/javascript">
<!--
function ValidateForm(theForm)
{
  if (theForm.title.value.length==0) { alert(html_entity_decode("',$L['E_mandatory'],': File")); return false; }
  return null;
}
-->
</script>
';

echo '<form method="post" action="',$oVIP->selfurl,'" onsubmit="return ValidateForm(this);">
<table class="ta" cellspacing="0">
<tr class="tr_t">
<th class="th_o th_o_all" colspan="3">',$L['Adm_settings'],'</th>
</tr>
';
echo '<tr class="tr_t">
<th class="th_o th_o_first" style="width:200px"><label for="format">',$L['export']['Format'],'</label></th>
<td class="td_o"><select id="format" name="format">
<option value="CSV"',($_SESSION['m_export']['format']=='CSV' ? QSEL : ''),'>',$L['export']['Csv'],'</option>
<option value="SQL"',($_SESSION['m_export']['format']=='SQL' ? QSEL : ''),'>',$L['export']['Sql'],'</option>
</select></td>
<td class="td_o">&nbsp;</td>
</tr>
';
echo '<tr class="tr_t">
<th class="th_o th_o_first"><label for="delimiter">',$L['export']['Delimiter'],'</label></th>
<td class="td_o"><input type="text" id="delimiter" name="delimiter" size="1" maxlength="2" value="',$_SESSION['m_export']['delimit'],'"/></td>
<td class="td_o">&nbsp;</td>
</tr>
';
echo '<tr class="tr_t">
<th class="th_o th_o_first"><label for="enclose">',$L['export']['Encloser'],'</label></th>
<td class="td_o"><input type="text" id="enclose" name="enclose" size="1" maxlength="2" value="',htmlspecialchars($_SESSION['m_export']['enclose']),'"/></td>
<td class="td_o"><span class="help">',$L['export']['H_Encloser'],'</span></td>
</tr>
';
echo '<tr class="tr_t">
<th class="th_o th_o_first"><label for="null">',$L['export']['Replace_null'],'</label></th>
<td class="td_o"><input type="text" id="null" name="null" size="5" maxlength="24" value="',$_SESSION['m_export']['null'],'"/></td>
<td class="td_o"><span class="help">&nbsp;</span></td>
</tr>
';
echo '<tr class="tr_t">
<th class="th_o th_o_first">',$L['export']['First_line'],'</th>
<td class="td_o" colspan="2"><input type="checkbox" id="firstline" name="firstline"',($_SESSION['m_export']['firstline']=='Y' ? QCHE : ''),'/><label for="firstline">',$L['export']['H_First_line'],'</label></td>
</tr>
';
echo '<tr class="tr_t">
<th class="th_o th_o_all" colspan="3">',$L['export']['Content'],'</th>
</tr>
';
echo '<tr class="tr_t">
<th class="th_o th_o_first"><label for="section">',$L['Section'],'</label></th>
<td class="td_o" colspan="2">
<select id="section" name="section" size="1">
<option value="*">&lt; ',$L['All'],' &gt;</option>',QTastags(GetSectionTitles('A')),'</select>
</td>
</tr>
';
echo '<tr class="tr_t">';
echo '<th class="th_o th_o_first">',$L['Messages'],'</th>';
echo '<td class="td_o"><select name="year" size="1">';
foreach ($arrYears as $intKey => $strValue)
{
echo '<option value="',$intKey,'">',$strValue,'</option>';
}
echo '</select></td>
<td class="td_o"><span class="help">&nbsp;</span></td>
</tr>
';
echo '<tr class="tr_t">
<th class="th_o th_o_first">',$L['export']['Drop_bbc'],'</th>
<td class="td_o" colspan="2"><input type="checkbox" id="dropbbc" name="dropbbc"',($_SESSION['m_export']['dropbbc']=='Y' ? QCHE : ''),'/><label for="dropbbc">',$L['export']['H_Drop_bbc'],'</label></td>
</tr>
';
echo '<tr class="tr_t">
<th class="th_o th_o_all" colspan="3">',$L['Destination'],'</th>
</tr>
';
echo '<tr class="tr_t">
<th class="th_o th_o_first"><label for="title">',$L['export']['Filename'],'</label></th>
<td class="td_o" colspan="2"><input type="text" id="title" name="title" size="32" maxlength="32" value="',$_SESSION['m_export']['title'],'"/></td>
</tr>';
echo '<tr class="tr_t">
<th class="th_o th_o_all" colspan="3" style="padding:6px; text-align:center"><input type="submit" name="submit" value="',$L['Ok'],'"/></th>
</tr>
';
echo '</table>';
echo '</form>';

// HTML END

include('qti_adm_p_footer.php');

?>